---
# install a basic csp report log file, consider alternatives if production

- name: Ensure csp directories exist
  ansible.builtin.file:
    dest: "{{ item.d }}"
    state: directory
    owner: "{{ item.o }}"
    mode: "{{ item.m }}"
  with_items:
    - { d: "{{ _hardenwebserver_rootdir }}/csp", o: root, m: '0755' }
    - { d: "{{ _hardenwebserver_rootdir }}/csp/log", o: "{{ www_user }}", m: '0755' }

- name: Configure csp-report script
  ansible.builtin.template:
    src: "{{ harden_apache_cspreport_template }}"
    dest: "{{ _hardenwebserver_rootdir }}/csp/report.php"
    mode: '0644'
    backup: true

- name: Ensure php is present
  ansible.builtin.package:
    name: "{{ item }}"
    state: present
  with_items: "{{ harden_apache_php }}"
  register: pkg_result
  until: pkg_result is success

- name: Push csp configuration
  ansible.builtin.template:
    src: "{{ item }}.j2"
    dest: "{{ apache_confdir }}/{{ item }}"
    mode: 0644
  with_items:
    - csp-apache.conf
  notify:
    - Restart apache
    - Restart apache - docker
- name: Enable csp configuration
  ansible.builtin.file:
    src: "{{ apache_confdir }}/{{ item }}"
    dest: "/etc/apache2/conf-enabled/{{ item }}"
    mode: '0644'
    state: link
  with_items:
    - csp-apache.conf
  notify:
    - Restart apache
    - Restart apache - docker
  when: ansible_distribution == 'Debian' or ansible_distribution == 'Ubuntu'
